<?php
class IMAP
{
	private $dom;
	private $server = null;
	private $connection = false;
	private $username;
	private $password;
	private $sizeOfPage = 20;
	private $currentMailbox;

	public function __construct()
	{
		header( "content-type: application/xml; charset=UTF-8" );
		$this->dom = new DOMDocument("1.0", "UTF-8");
		$this->dom->formatOutput = true;
		$this->dom->appendChild($this->dom->createProcessingInstruction('xml-stylesheet', 'type="text/xsl" href="xsl/mailbox.xsl"'));
		$this->dom->appendChild($this->dom->createElement('expressoMail'));

		$this->server = '{127.0.0.1:143/notls/novalidate-cert}';
		$this->username = 'expresso-admin';
		$this->password = 'senha';
		$this->_open();
	}

	public function __destruct()
	{
		if ( $this->connection )
			imap_close($this->connection);
	}

	public function __toString()
	{
		return
		   __CLASS__;
	}

	public function __sleep()
	{
		return
			array
			(
			);
	}

	public function __call($name, $arguments)
	{
		if ( $name === 'error' )
			return
				imap_errors();

		if ( !$this->connection )
			return false;

		switch ( $name )
		{
			case 'getResult' :
				return
					$this->dom->saveXML();
				break;
			case 'listOfMailboxes' :
				return
					$this->_listOfMailboxes();
				break;
			case 'readAPageOfMailbox' :
				$page = ( is_numeric($arguments[0]) ) ? $arguments[0] : 1;
				#$this->_readAPageOfMailbox($page);
				return
					$this->_readAPageOfMailboxOrderedBy($page, $arguments[1], $arguments[2], $arguments[3]);
				break;
			case 'setCurrentMailbox' :
				return
					$this->_setCurrentMailbox($arguments[0]);
				break;
			case 'setSizeOfPage' :
				if ( is_numeric($arguments[0]) && $arguments[0] > 0 )
					$this->sizeOfPage = $arguments[0];
				break;
			#case 'getsTheNumberOfMessages' :
			#	return $this->_getsTheNumberOfMessagesInFolder();
			#break;
			default :
				return "Call not avaible";
		}
	}

	private function _checkCurrentMailbox()
	{
		$check = imap_check($this->connection);
		$check->Mailbox = substr($check->Mailbox, (strpos($check->Mailbox, '}') + 1));
		return
			$check;
	}

	private function _getStatusOfMailbox($pMailbox = false)
	{
		if ( !is_string($pMailbox) )
			return
				false;

		$status = (array)imap_status($this->connection, $this->server . $pMailbox, SA_MESSAGES + SA_RECENT + SA_UNSEEN);
		#$status['mailbox'] = $pMailbox;
		unset($status['flags']);

		return
			$status;
	}

	private function _getTheNumberOfMessagesInMailbox()
	{
		return
			imap_num_msg($this->connection);
	}

	private function _listOfMailboxes()
	{
		$list = imap_list($this->connection, $this->server, "*");
		$return = array();
		if ( !is_array($list) )
			return
				false;

		$mailboxes = $this->dom->createElement('mailboxes');
		$this->dom->documentElement->appendChild($mailboxes);
		foreach ($list as $val)
		{
			$mailbox = str_replace($this->server, '', imap_utf7_decode($val));
			$attributes = $this->_getStatusOfMailbox($mailbox);

			$mailbox = explode('/', $mailbox);
			$mailbox_deep = sizeof($mailbox);
			$parent = $mailboxes;

			for ( $i = 0; $i < $mailbox_deep; $i++ )
			{
				$node = $parent->firstChild;
				$met = false;
				while ( $node && !$met )
					if ( $node->nodeName == $mailbox[$i] )
						$met = true;
					else
						$node = $node->nextSibling;

				if ( !$node )
				{
					$node = $this->dom->createElement($mailbox[$i]);

					foreach ( $attributes as $name => $value )
					{
						$attr = $this->dom->createAttribute($name);
						$attr->appendChild($this->dom->createTextNode($value));
						$node->appendChild($attr);
					}

					$parent->appendChild($node);
				}

				$parent = $node;
			}
		}

		return
			true;
	}

	private function _open()
	{
		$this->connection = imap_open($this->server.'/INBOX', $this->username, $this->password);
	}

	private function _readAPageOfMailbox($pPage = false)
	{
		# parameter page should be a number greater than zero
		if ( !(is_numeric($pPage) && ($pPage = (int)$pPage) > 0) )
			return
				false;

		# get the number of messages in the mailbox
		$numberOfMessages = $this->_getTheNumberOfMessagesInMailbox();

		# if the page parameter is greater than the number
		# of pages valid then it is invalid and therefore
		# the return is false
		if ( $pPage > ceil($numberOfMessages / $this->sizeOfPage) )
			return
				false;

		$last = $pPage * $this->sizeOfPage;
		$first = $last - $this->sizeOfPage;

		if ( ++$first < 1 )
			$first = 1;

		if ( $last > $numberOfMessages )
			$last = $numberOfMessages;

		$mailbox = $this->dom->createElement('mailbox');
		$this->dom->documentElement->appendChild($mailbox);

		$attr = $this->dom->createAttribute('name');
		$attr->appendChild($this->dom->createTextNode($this->currentMailbox));
		$mailbox->appendChild($attr);

		$attr = $this->dom->createAttribute('page');
		$attr->appendChild($this->dom->createTextNode($pPage));
		$mailbox->appendChild($attr);

		$headers = imap_fetch_overview($this->connection, $first . ':' . $last);
		foreach ( $headers as $header )
		{
			$message = $this->dom->createElement('message');
			$mailbox->appendChild($message);
			foreach ( $header as $name => $value )
				switch ( ($name = strtolower($name)) )
				{
					case 'from' :
					case 'date' :
						if ( $name == 'date' )
						{
							$attr = $this->dom->createAttribute('timestamp');
							$attr->appendChild($this->dom->createTextNode(strtotime($value)));
							$message->appendChild($attr);
						}
					case 'subject' :
					case 'recent' :
					case 'seen' :
					case 'flagged' :
					case 'answered' :
					case 'deleted' :
					case 'draft' :
					case 'msgno' :
					case 'size' :
						$attr = $this->dom->createAttribute($name);
						$attr->appendChild($this->dom->createTextNode(trim($value)));
						$message->appendChild($attr);
						break;
				}
		}
	}

	# read a page of the mailbox ordered by
	private function _readAPageOfMailboxOrderedBy($pPage = false, $pSort = false, $pOrder = false, $pSearch = false)
	{
		# parameter page should be a number greater than zero
		if ( !(is_numeric($pPage) && ($pPage = (int)$pPage) > 0) )
			return
				false;

		# get the number of messages in the mailbox
		$numberOfMessages = $this->_getTheNumberOfMessagesInMailbox();

		# if the page parameter is greater than the number
		# of pages valid then it is invalid and therefore
		# the return is false
		if ( $pPage > ceil($numberOfMessages / $this->sizeOfPage) )
			return
				false;

		# if the order parameter is not valid then the
		# default value is assigned (date of arrival)
		if ( !is_string($pSort) )
		{
			$pSort = 'arrival';
			$sort = SORTARRIVAL;
			if ( !is_string($pOrder) )
				$pOrder = 'Descending';
		}
		else
			switch ( strtolower($pSort) )
			{
				case 'date' :
					$sort = SORTDATE;
					break;
				case 'arrival' :
					$sort = SORTARRIVAL;
					if ( !is_string($pOrder) )
						$pOrder = 'Descending';
					break;
				case 'from' :
					$sort = SORTFROM;
					break;
				case 'subject' :
					$sort = SORTSUBJECT;
					break;
				case 'to' :
					$sort = SORTTO;
					break;
				case 'cc' :
					$sort = SORTCC;
					break;
				case 'size' :
					$sort = SORTSIZE;
					break;
				default :
					$pSort = 'arrival';
					$sort = SORTARRIVAL;
					break;
			}

		# if the sort parameter is not valid
		# (Ascending or Descending) then the
		# default value is assigned (Ascending)
		if ( !is_string($pOrder) )
		{
			$pOrder = 'Ascending';
			$order = 0;
		}
		else
			switch ( strtolower($pOrder) )
			{
				case 'ascending' :
					$order = 0;
					break;
				case 'descending' :
					$order = 1;
					break;
				default :
					$pOrder = 'Ascending';
					$order = 0;
			}

		$last = $pPage * $this->sizeOfPage;
		$first = $last - $this->sizeOfPage;

		if ( ++$first < 1 )
			$first = 1;

		if ( $last > $numberOfMessages )
			$last = $numberOfMessages;

		$sorted = imap_sort($this->connection, $sort, $order, SE_NOPREFETCH, $pSearch);
		$sorted = array_slice($sorted, $first - 1, $this->sizeOfPage);

		$mailbox = $this->dom->createElement('mailbox');
		$this->dom->documentElement->appendChild($mailbox);

		$attr = $this->dom->createAttribute('name');
		$attr->appendChild($this->dom->createTextNode($this->currentMailbox));
		$mailbox->appendChild($attr);

		$attr = $this->dom->createAttribute('page');
		$attr->appendChild($this->dom->createTextNode($pPage));
		$mailbox->appendChild($attr);

		$attr = $this->dom->createAttribute('sort');
		$attr->appendChild($this->dom->createTextNode($pSort));
		$mailbox->appendChild($attr);

		$attr = $this->dom->createAttribute('order');
		$attr->appendChild($this->dom->createTextNode($pOrder));
		$mailbox->appendChild($attr);

		return
			$this->_readRangFromMailbox($sorted, $mailbox);
	}

	private function _readRangFromMailbox(array $pRange, $pMailbox)
	{
		foreach ( $pRange as $message_number )
		{
			$message = $this->dom->createElement('message');
			$pMailbox->appendChild($message);

			$header = imap_headerinfo($this->connection, $message_number);
			foreach ( $header as $name => $value )
				switch ( trim($name = strtolower($name)) )
				{
					case 'fromaddress' :
						if ( $name == 'fromaddress' )
							$name = 'from';
					case 'date' :
						if ( $name == 'date' )
						{
							$attr = $this->dom->createAttribute('timestamp');
							$attr->appendChild($this->dom->createTextNode(strtotime($value)));
							$message->appendChild($attr);
						}
					case 'subject' :
					case 'recent' :
					case 'unseen' :
						if ( $name == 'unseen' )
						{
							$name = 'seen';
							$value = ( $value == 'U' ) ? 0 : 1;
						}
					case 'flagged' :
					case 'answered' :
					case 'deleted' :
					case 'draft' :
					case 'msgno' :
					case 'size' :
						$attr = $this->dom->createAttribute($name);
						$value = trim($value);
						$value = ( !empty($value) ) ? $value : 0;
						$attr->appendChild($this->dom->createTextNode($value));
						$message->appendChild($attr);
				}
		}

		return
			true;
	}

	private function _setCurrentMailbox($pFolder = false)
	{
		if ( !$pFolder || empty($pFolder) )
			return false;

		$this->currentMailbox = mb_convert_encoding($pFolder, "UTF7-IMAP","ISO_8859-1");

		return
			imap_reopen($this->connection, $this->server . $this->currentMailbox);
	}
}
?>
